routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\CastController;
use App\Http\Controllers\GenreController;
use App\Http\Controllers\FilmController;
use App\Http\Controllers\IndexController;
use App\Http\Controllers\KomentarController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [IndexController::class, 'index']);
Route::get('/register', [AuthController::class, 'register']);
Route::post('/welcome', [AuthController::class, 'welcome']);

Route::middleware(['auth'])->group(function(){

    Route::get('/data-table', [IndexController::class, 'datatable']);

});
// Route::get('/master', function(){

//     return view('layout.master');
// });
// Route::get('/', function () {
//     return view('welcome');
// });


Route::resource('cast', CastController::class);
Route::resource('film', FilmController::class);
Route::resource('genre', GenreController::class);
Route::resource('film', FilmController::class);

Route::middleware(['auth'])->group(function(){
    Route::get('cast/delete/{id}', [CastController::class, 'delete'])->name('delete');
    Route::get('genre/delete/{id}', [GenreController::class, 'delete'])->name('genre.delete');
    Route::get('film/delete/{id}', [FilmController::class, 'delete'])->name('film.delete');
    Route::post('komentar', [KomentarController::class, 'store']);
});

Auth::routes();

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Genre.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Genre extends Model
{
    use HasFactory;

    protected $fillable = ['nama'];

    public function films(){
        
        return $this->hasMany(Film::class, 'genre_id');
    }
}

app/Http/Controllers/GenreController.php
<?php

namespace App\Http\Controllers;

use App\Models\Genre;
use Illuminate\Http\Request;

class GenreController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth')->except('index', 'show');
    }    
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $genres = Genre::all();

        return view('pages.genre.index', compact('genres'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.genre.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'nama' => 'required|max:45'
        ]);

        Genre::create(
            ['nama' => $request->nama]
        );

        return redirect('genre')->with('success', 'Genre berhasil ditambahkan!');
        // return view('pages.genre.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $genre = Genre::find($id);

        return view('pages.genre.detail', compact('genre'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $genre = Genre::find($id);
        
        return view('pages.genre.edit', compact('genre'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'nama' => 'required|max:45'
        ]);

        $genre = Genre::find($id);
        $genre->nama = $request->nama;
        $genre->update();

        return redirect('genre')->with('success', 'Genre berhasil diupdate!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $genre = Genre::find($id);
        $genre->delete();

        return redirect('genre')->with('success', 'Genre berhasil dihapus!');

    }

    public function delete($id)
    {
        $genre = Genre::find($id);
        return view('pages.genre.delete', compact('genre'));
    }
}

resources/views/pages/genre/create.blade.php
@extends('layout.master')

@section('content')

<div class="card">
    <div class="card-header">
        <h3 class="card-title">Tambah Genre</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <form action="/genre" method="post">
            @csrf
            <div class="form-group row">
                <div class="col-sm-6">
                    <label>Nama</label>
                    <input type="text" name="nama" id="nama" class="form-control form-control-sm">
                    @error('nama')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror

                </div>
            </div>
            <button type="submit" class="btn btn-sm btn-primary">Simpan</button>
        </form>
    </div>
</div>
    
@endsection

resources/views/pages/genre/delete.blade.php
{{-- DELETE MODAL BODY --}}
<form action="{{route('genre.destroy', $genre->id)}} " method="post">
    <div class="modal-body">
        @csrf
        @method('DELETE')
        <h5 class="text-center">Anda yakin menghapus {{ $genre->nama }}?</h5>
        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">Tidak</button>
            <button type="submit" class="btn btn-sm btn-danger">Ya, Hapus</button>
        </div>

    </div>
    
</form>

resources/views/pages/genre/detail.blade.php
@extends('layout.master')

@section('content')

<div class="card">
    <div class="card-header">
        <h3>Detail Genre</h3>        
    </div>
    <div class="card-body">
        <div class="row">
            <div class="col-sm-3">Nama</div>
            <div class="col-sm-9">: {{$genre->nama}} </div>
        </div>
        <div class="row">
            <div class="col-sm-3">Film ({{count($genre->films)}})</div>
            <div class="col-sm-9">: 
                <ul>
                    @forelse ($genre->films as $item)
                    <li><a href="/film/{{$item->id}}">{{ $item->judul}}</a></li>
                    @empty
                    <li></li>
                    @endforelse
                </ul>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-3">Dibuat pada</div>
            <div class="col-sm-9">: {{ $genre->created_at->format('d/m/Y')}} </div>
        </div>
        <a href="/genre" class="btn btn-sm btn-block btn-secondary my-5">Kembali</a>
    </div>
</div>
    
@endsection

resources/views/pages/genre/edit.blade.php
@extends('layout.master')

@section('content')

    <div class="card">
        <div class="card-header">
            <div class="card-title">

            </div>
        </div>
        <div class="card-body">
            <form action="/genre/{{$genre->id}}" method="post">
                @csrf
                @method('PUT')
                <div class="form-group row">
                    <div class="col-sm-6">
                        <label>Nama</label>
                        <input type="text" name="nama" id="nama" value="{{$genre->nama}}" class="form-control form-control-sm">
                        @error('nama')
                            <div class="alert alert-danger">
                                {{$message}}
                            </div>
                        @enderror
    
                    </div>
                </div>
                <button type="submit" class="btn btn-sm btn-primary">Simpan</button>
            </form>
        </div>
    </div>
    
@endsection

resources/views/pages/genre/index.blade.php
@extends('layout.master')

@section('content')

@if (session('success'))
    <div class="alert alert-success">
        {{ session('success') }}
    </div>
@endif

<div class="card">
    <div class="card-header">
        <h3 class="card-title">List Genre</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <table id="genreTable" class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>#</th>
                    <th colspan="2">Nama Genre</th>
                </tr>
            </thead>
            <tbody>

                @forelse ($genres as $key => $item)
                <tr>
                    <td>{{$key+1}} </td>
                    <td>{{$item->nama }} </td>
                    <td>
                        <a href="{{route('genre.show', $item->id)}} " class="btn btn-sm btn-info">Detail</a>
                        @auth
                        <a href="{{route('genre.edit', $item->id)}} " class="btn btn-sm btn-warning">Edit</a>
                        <a href="" class="btn btn-sm btn-danger" id="deleteButton" data-toggle="modal" data-target="#deleteModal" data-attr="{{route('genre.delete', $item->id)}} ">
                            Hapus
                        </a>
                        @endauth
                    </td>
                </tr>
                    
                @empty

                <tr>
                    <td colspan="3"><i>Tidak ada genre</i></td>
                </tr>
                    
                @endforelse

            </tbody>
            <tfoot>

            </tfoot>
        </table>
        {{-- <div class="row">
            @forelse ($genres as $item)
    
            <div class="card col-sm-4 mx-1" style="width: 18rem;">
                <div class="card-body">
                <h5 class="card-title">{{$item->nama}} </h5> 
                <br> <hr>
                <div class="row">
                    <a href="/genre/{{$item->id}}" class="btn btn-sm btn-primary mx-1"> Detail</a>
                    <a href="/genre/{{$item->id}}/edit" class="btn btn-sm btn-warning mx-1"> Edit</a>
                    <a class="btn btn-sm btn-danger" data-toggle="modal" id="buttonDelete" data-target="#deleteModal" data-attr="{{ route('delete', $item->id) }}" title="Delete Cast">
                        Delete
                        <i class="fas fa-trash text-danger fa-lg"></i>
                    </a>
                </div>
                </div>
            </div>

            @empty
            
            <i>Tidak ada list genre</i>
            
            @endforelse
        </div> --}}
    </div>
</div>

{{-- DELETE MODAL --}}

<div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="smallModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-sm" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body" id="deleteBody">
                <div>
                    {{-- MODAL FORM DELETE --}}
                </div>
            </div>
        </div>
    </div>
</div>
    
@endsection

@push('script')

<script>
    // display a modal (small modal)
    $(document).on('click', '#deleteButton', function(event) {
        event.preventDefault();
        let href = $(this).attr('data-attr');
        console.log(href)
        $.ajax({
            url: href, 
            // beforeSend: function() {
            //     $('#loader').show();
            // },
            // return the result
            success: function(result) {
                $('#deleteModal').modal("show");
                $('#deleteBody').html(result).show();
            }, 
            // complete: function() {
            //     $('#loader').hide();
            // }, 
            error: function(jqXHR, testStatus, error) {
                console.log(error);
                alert("Page " + href + " cannot open. Error:" + error);
                $('#loader').hide();
            }, 
            timeout: 8000
        })
    });

</script>
    
@endpush